import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataKubernetesMutatingWebhookConfigurationV1Config extends cdktf.TerraformMetaArguments {
    /**
     * metadata block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#metadata DataKubernetesMutatingWebhookConfigurationV1#metadata}
     *
     * @stability stable
     */
    readonly metadata: DataKubernetesMutatingWebhookConfigurationV1Metadata;
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookClientConfigService extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get port(): number;
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookClientConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get caBundle(): string;
    /**
     * @stability stable
     */
    get service(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get url(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookNamespaceSelectorMatchExpressions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    get operator(): string;
    /**
     * @stability stable
     */
    get values(): string[];
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookNamespaceSelector extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get matchExpressions(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get matchLabels(): {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookObjectSelectorMatchExpressions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    get operator(): string;
    /**
     * @stability stable
     */
    get values(): string[];
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookObjectSelector extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get matchExpressions(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get matchLabels(): {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1WebhookRule extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get apiGroups(): string[];
    /**
     * @stability stable
     */
    get apiVersions(): string[];
    /**
     * @stability stable
     */
    get operations(): string[];
    /**
     * @stability stable
     */
    get resources(): string[];
    /**
     * @stability stable
     */
    get scope(): string;
}
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1Webhook extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get admissionReviewVersions(): string[];
    /**
     * @stability stable
     */
    get clientConfig(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get failurePolicy(): string;
    /**
     * @stability stable
     */
    get matchPolicy(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get namespaceSelector(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get objectSelector(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get reinvocationPolicy(): string;
    /**
     * @stability stable
     */
    get rule(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get sideEffects(): string;
    /**
     * @stability stable
     */
    get timeoutSeconds(): number;
}
/**
 * @stability stable
 */
export interface DataKubernetesMutatingWebhookConfigurationV1Metadata {
    /**
     * An unstructured key value map stored with the mutating webhook configuration that may be used to store arbitrary metadata.
     *
     * More info: http://kubernetes.io/docs/user-guide/annotations
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#annotations DataKubernetesMutatingWebhookConfigurationV1#annotations}
     *
     * @stability stable
     */
    readonly annotations?: {
        [key: string]: string;
    };
    /**
     * Map of string keys and values that can be used to organize and categorize (scope and select) the mutating webhook configuration.
     *
     * May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#labels DataKubernetesMutatingWebhookConfigurationV1#labels}
     *
     * @stability stable
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * Name of the mutating webhook configuration, must be unique. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1#name DataKubernetesMutatingWebhookConfigurationV1#name}
     *
     * @stability stable
     */
    readonly name?: string;
}
export declare function dataKubernetesMutatingWebhookConfigurationV1MetadataToTerraform(struct?: DataKubernetesMutatingWebhookConfigurationV1MetadataOutputReference | DataKubernetesMutatingWebhookConfigurationV1Metadata): any;
/**
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1MetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DataKubernetesMutatingWebhookConfigurationV1Metadata | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DataKubernetesMutatingWebhookConfigurationV1Metadata | undefined);
    private _annotations?;
    /**
     * @stability stable
     */
    get annotations(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set annotations(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAnnotations(): void;
    /**
     * @stability stable
     */
    get annotationsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get generation(): number;
    private _labels?;
    /**
     * @stability stable
     */
    get labels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set labels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetLabels(): void;
    /**
     * @stability stable
     */
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceVersion(): string;
    /**
     * @stability stable
     */
    get uid(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1 kubernetes_mutating_webhook_configuration_v1}.
 *
 * @stability stable
 */
export declare class DataKubernetesMutatingWebhookConfigurationV1 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/kubernetes/d/mutating_webhook_configuration_v1 kubernetes_mutating_webhook_configuration_v1} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataKubernetesMutatingWebhookConfigurationV1Config);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    webhook(index: string): DataKubernetesMutatingWebhookConfigurationV1Webhook;
    private _metadata;
    /**
     * @stability stable
     */
    get metadata(): DataKubernetesMutatingWebhookConfigurationV1MetadataOutputReference;
    /**
     * @stability stable
     */
    putMetadata(value: DataKubernetesMutatingWebhookConfigurationV1Metadata): void;
    /**
     * @stability stable
     */
    get metadataInput(): DataKubernetesMutatingWebhookConfigurationV1Metadata | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
